
capture program drop parrot
program parrot
	version 14
	display "`1'" 
end


sjlog using logs/ch11.01,replace
type parrot.ado
parrot "This is Stata..."
sjlog close, replace


!rm pctrange.ado
!cp pctrange.100.ado pctrange.ado
program drop _all

sjlog using logs/ch11.02, replace
type pctrange.ado
sjlog close, replace


sjlog using logs/ch11.03, replace
use mcas, clear
pctrange tot_day
display p7525
sjlog close, replace

!cp pctrange.101.ado pctrange.ado
program drop _all

sjlog using logs/ch11.04, replace
type pctrange.ado
sjlog close, replace

!cp pctrange.102.ado pctrange.ado
program drop _all

sjlog using logs/ch11.04a, replace
type pctrange.ado
sjlog close, replace

use mcas
sjlog using logs/ch11.05, replace
discard
quietly pctrange tot_day
return list
sjlog close, replace

!cp pctrange.103.ado pctrange.ado
program drop _all

sjlog using logs/ch11.06, replace
type pctrange.ado
sjlog close, replace

!cp pctrange.104.ado pctrange.ado
program drop _all

sjlog using logs/ch11.06a, replace
type pctrange.ado
sjlog close, replace

!cp pctrange.105.ado pctrange.ado
program drop _all

sjlog using logs/ch11.07, replace
type pctrange.ado
sjlog close, replace

sjlog using logs/ch11.08, replace
summarize percap, meanonly
pctrange tot_day if percap > r(mean) & !missing(percap)
sjlog close, replace

!cp pctrange.106.ado pctrange.ado
program drop _all

sjlog using logs/ch11.09, replace
type pctrange.ado
sjlog close, replace

use mcas, clear
sjlog using logs/ch11.10, replace
discard
pctrange regday specneed bilingua occupday tot_day tchratio, format(%9.2f) 
sjlog close, replace

sjlog using logs/ch11.11, replace
pctrange regday specneed bilingua occupday tot_day tchratio, mat(MCAS) noprint
outtable using MCAS, mat(MCAS) caption("{\smrm MCAS} percentile ranges\label{mcas}") ///
format(%9.2f) nobox replace
sjlog close, replace

sjlog using logs/ch11.12, replace
discard
summarize avgsalry, meanonly
generate byte highsal = avgsalry > r(mean) & !missing(avgsalry)
label define sal 0 low 1 high
label val highsal sal
tabstat avgsalry, by(highsal) stat(mean N)
bysort highsal: pctrange regday specneed bilingua occupday tot_day tchratio
sjlog close, replace

!cp _gpct9010.100.ado _gpct9010.ado
program drop _all

sjlog using logs/ch11.13, replace
type _gpct9010.ado
sjlog close, replace

!cp _gpct9010.101.ado _gpct9010.ado
program drop _all

sjlog using logs/ch11.14, replace
type _gpct9010.ado
sjlog close, replace

sjlog using logs/ch11.15, replace
sysuse auto, clear
bysort rep78 foreign: egen pctrange = pct9010(price)
sjlog close, replace

sjlog using logs/ch11.16, replace
chelp pctrange
sjlog close, replace

!cp mynormal_lf.100.ado mynormal_lf.ado
program drop _all

sjlog using logs/ch11.17, replace
type mynormal_lf.ado
sjlog close, replace

sjlog using logs/ch11.17a, replace
sysuse auto, clear
ml model lf mynormal_lf (mpg = ) /sigma 
ml maximize, nolog
summarize mpg if e(sample)
sjlog close, replace

sjlog using logs/ch11.17b, replace
ml model lf mynormal_lf (mpg = weight displacement) /sigma 
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17c, replace
ml model lf mynormal_lf (mpg = weight displacement turn) (foreign)  
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17d, replace
type myexp_lf.ado
sjlog close, replace

sjlog using logs/ch11.17dd, replace
prog drop _all
clear
input y
2.1
2.2
3.1
1.6
2.5
0.5
end
ml model lf myexp_lf (y = ) 
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17e, replace
type mycauchy_lf.ado
sjlog close, replace

sjlog using logs/ch11.17ee, replace
clear
input y
2
5
-2
3
3
end
ml model lf mycauchy_lf (y= )
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17f, replace
type myvasicek_lf.ado
sjlog close, replace

sjlog using logs/ch11.17ff, replace
use eurodata, clear
generate r = 100 * col4
generate t = _n
tsset t
ml model lf myvasicek_lf (mu:r= ) /sigma2
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17g, replace
type myvasicek2_lf.ado
sjlog close, replace

sjlog using logs/ch11.17gg, replace
use eurodata, clear
generate r = 100 * col4
generate t = _n
tsset t
ml model lf myvasicek2_lf (alpha:r = L.r) /sigma2 
ml maximize, nolog
sjlog close, replace

sjlog using logs/ch11.17ggg, replace
display as err _n "Beta"
lincom [alpha]L.r - 1
display as err _n "Mu_s"
nlcom -1 * [alpha]_cons / ([alpha]L.r - 1)
display as err _n "Sigma^2_s"
nlcom -1 * [sigma2]_cons / (([alpha]L.r - 1) * (2 + ([alpha]L.r - 1)))
sjlog close, replace

sjlog using logs/ch11.17h, replace
type mygamma_lf.ado
sjlog close, replace

sjlog using logs/ch11.17hh, replace
use eurodata, clear
rename col4 r
generate t = _n
tsset t
ml model lf mygamma_lf (nu:r= ) /omega
ml maximize, nolog
display as err _n "Estimated Mu"
nlcom [nu]_cons / ([omega]_cons)
sjlog close, replace

!cp mynormal.100.ado mynormal.ado
program drop _all

sjlog using logs/ch11.18, replace
type mynormal.ado
sjlog close, replace

sysuse auto,clear
sjlog using logs/ch11.19, replace
mynormal price mpg weight turn
sjlog close, replace

sjlog using logs/ch11.20, replace
mynormal, level(90)
test weight = 5
predict double pricehat, xb
summarize price pricehat
sjlog close, replace

sjlog using logs/ch11.21, replace
type nlces.ado
sjlog close, replace

sjlog using logs/ch11.22, replace
use production, clear
nl ces @ lnoutput capital labor, parameters(b0 rho delta) ///
 initial(b0 0 rho 1 delta 0.5)
sjlog close, replace

sjlog using logs/ch11.23, replace
nlcom (sigma: 1 / (1 + [rho]_b[_cons]))
sjlog close, replace
     
sjlog using logs/gmm1, replace
program gmm_reg
	version 14
	syntax varlist if, at(name)
	quietly {
		tempvar xb
		generate double `xb' = x1*`at'[1,1] + x2*`at'[1,2] + ///
		   x3*`at'[1,3] + `at'[1,4] `if'
		replace `varlist' = y - `xb' `if'
	}
end
sjlog close, replace

sjlog using logs/gmm2, replace
sysuse auto, clear
generate y = price
generate x1 = weight
generate x2 = length
generate x3 = turn
gmm gmm_reg, nequations(1) parameters(b1 b2 b3 b0) ///
    instruments(weight length turn) onestep nolog
sjlog close, replace

capt prog drop gmm_reg2
sjlog using logs/gmm3a, replace
program gmm_reg2
	version 14
	syntax varlist if, at(name) mylhs(varlist)
	quietly {
		tempvar xb
		matrix score double `xb' = `at' `if', eq(#1)
		replace `varlist' = `mylhs' - `xb' `if'
	}
end
sjlog close, replace

sjlog using logs/gmm3b, replace
sysuse auto, clear
local dv price
gmm gmm_reg2, nequations(1) parameters(`dv':weight `dv':length `dv':turn `dv':_cons) ///
     instruments(weight length turn) mylhs(`dv') nolog
sjlog close, replace

sjlog using logs/gmm3c, replace
webuse hsng2, clear
local dv rent
gmm gmm_reg2, nequations(1) parameters(`dv':hsngval `dv':pcturban `dv':popden `dv':_cons) ///
    instruments(pcturban popden faminc reg2-reg4) mylhs(`dv') nolog
sjlog close, replace

capt prog drop gmm_probit
sjlog using logs/gmm4, replace
program gmm_probit
    version 14
    syntax varlist if, at(name) mylhs(varlist)
    quietly {
       tempvar xb G g
       matrix score double `xb' = `at' `if', eq(#1)
       generate double     `G'  = normal(`xb')
       generate double     `g'  = normalden(`xb')
       replace `varlist'        = `g'*(`mylhs'-`G')/(`G'*(1-`G'))
    }
end
sjlog close, replace

sjlog using logs/gmm5, replace
sysuse auto, clear
local dv foreign
gmm gmm_probit, nequations(1) parameters(`dv':gear_ratio `dv':displacement `dv':_cons) ///
    instruments(gear_ratio displacement) mylhs(`dv') nolog
sjlog close, replace    

sjlog using logs/gmm5b, replace
probit foreign gear_ratio displacement, vce(robust)
sjlog close, replace

program drop _all

sjlog using logs/ch11.24, replace
type mcsimul.ado
sjlog close, replace

sjlog using logs/ch11.25, replace
set seed 20140208
use census2, clear
generate z_factor = 10 * region
summarize z_factor, meanonly
scalar zmu = r(mean)
quietly	simulate  p1=r(p1) p2=r(p2), /// 
	saving(mcsimul,replace) nodots reps(10000): mcsimul drate, mu(80)
sjlog close, replace


sjlog using logs/ch11.26, replace
use mcsimul, clear
generate R5pc_1 = (p1 < 0.05) 
generate R5pc_2 = (p2 < 0.05)
summarize 
sjlog close, replace

