clear

sjlog using logs/ch13.onela, replace
sysuse auto
regress price displacement weight foreign
mata: st_matrix("bst",(st_matrix("e(b)") \ ///
sqrt(diagonal(st_matrix("e(V)"))') \ ///
st_matrix("e(b)") :/ sqrt(diagonal(st_matrix("e(V)"))')))
matrix rownames bst = coeff stderr tstat
matrix colnames bst = `: colnames e(b)' 
matrix list bst, format(%9.3f)
sjlog close, replace

sjlog using logs/ch13.onelaa, replace
quietly regress price displacement weight foreign
mata: st_matrix("bstp", (st_matrix("r(table)")[(1..4),.]))
matrix rownames bstp = coeff stderr tstat pvalue 
matrix colnames bstp = `: colnames e(b)'
matrix list bstp, format(%9.3f)
sjlog close, replace


set more off
clear all
set obs 20
foreach y in 1994 1997 2001 2003 2005 {
	g exp`y' = log(2 * `y') + rnormal()
}
sjlog using logs/ch13.onelb, replace
list exp*, separator(0)
local defl 87.6 97.4 103.5 110.1 117.4
sjlog close, replace

sjlog using logs/ch13.onelc, replace
mata: expend = st_view(X=., ., "exp1994 exp1997 exp2001 exp2003 exp2005"); ///
D = 0.01 :* strtoreal(tokens(st_local("defl"))); X[.,.] = X :/ D
sjlog close, replace

sjlog using logs/ch13.oneld, replace
rename exp* rexp*
list rexp*, separator(0)
sjlog close, replace

sjlog using logs/ch13.onele, replace
forvalues i=1/5 {
mata
j = log(strtoreal(st_local("i"))); j
end
}
sjlog close, replace

cscript
sjlog using logs/ch13.onelf, replace
forvalues i=1/5 {
mata: j = log(strtoreal(st_local("i"))); j
}
sjlog close, replace

sjlog using logs/ch13.00a, replace
type varextrema.ado
sjlog close, replace

do calcextrema.mata

sjlog using logs/ch13.00b, replace
type calcextrema.mata
sjlog close, replace


sjlog using logs/ch13.00c, replace
sysuse auto, clear
varextrema price if foreign
return list
sjlog close, replace

program drop _all
mata: mata clear

sjlog using logs/ch13.02,replace
type centervars.ado
sjlog close, replace

sjlog using logs/ch13.02a, replace
type centerv.mata
sjlog close, replace

do centerv.mata

sjlog using logs/ch13.03,replace
sysuse auto, clear
centervars price mpg, gen(c_)
centervars price mpg if foreign, gen(cf_) double
summarize c*
sjlog close, replace

program drop _all
mata: mata clear
sjlog using logs/ch13.04a, replace
type avgper.ado
sjlog close, replace

do avgper.mata

sjlog using logs/ch13.04b, replace
type avgper.mata
sjlog close, replace

sjlog using logs/ch13.04, replace
use urates, clear
tsset
avgper tenn, per(3)  // calculate quarterly averages
avgper tenn, per(12) // calculate annual averages
summarize tenn*
sjlog close, replace


sjlog using logs/ch13.05, replace
tsmktim quarter, start(1978q1) // create quarterly calendar var
tsmktim year, start(1978)      // create annual calendar var
list t tenn quarter tennA3 year tennA12 in 1/12, separator(3)
sjlog close, replace


sjlog using logs/ch13.06, replace
use urates, clear
foreach v of varlist tenn-arkansas {
	avgper `v', per(3)
}
summarize tenn-arkansasA3, separator(6)
sjlog close, replace

sjlog using logs/ch13.07, replace
type aggreg.ado
sjlog close, replace

do aggreg.mata

sjlog using logs/ch13.08, replace
type aggreg.mata
sjlog close, replace

clear

sjlog using logs/ch13.09, replace
use urates, clear
aggreg tenn, per(3)  // calculate quarterly averages
aggreg tenn, per(3) func(sum) // calculate quarterly sum
aggreg tenn, per(3) func(first) // extract first month's value
aggreg tenn, per(3) func(last) // extract first month's value
tsmktim quarter, start(1978q1) // create quarterly calendar var
list t tenn quarter tennA3 tennS3 tennF3 tennL3 in 1/12, separator(3)
sjlog close, replace


sjlog using logs/ch14.mlea, replace
type mynormal_lf.ado
sjlog close, replace

clear all

sjlog using logs/ch14.mleb, replace
version 14
mata:

void mynormal_lf( transmorphic scalar ML,
                  real rowvector b,
                  real colvector lnfj)
{
	real vector depvar, xb
	real scalar sigma
	depvar = moptimize_util_depvar(ML, 1)
	xb = moptimize_util_xb(ML, b, 1)
	sigma = moptimize_util_xb(ML, b, 2)
	
	lnfj = ln( normalden( depvar, xb, sigma) )
}
end
sjlog close, replace

sjlog using logs/ch14.mlec, replace
sysuse auto, clear
ml model lf mynormal_lf() (mpg = weight displacement) /sigma
ml maximize, nolog
sjlog close, replace

mata:
void foo(real scalar bar)
{
        pointer(real matrix) rowvector ap
        ap = J(1, bar, NULL)
        real scalar i
        for(i=1; i<=bar; i++) {
                ap[i] = &(runiform(3,3))
        }
        for(i=1; i<=bar; i++) {
                i
                *ap[i]
        }
}
end

mata:
void pointer2(real scalar bar1, real scalar bar2)
{
	pointer(pointer(real matrix) rowvector) rowvector pp
	pp = J(1,bar2,NULL)
        real scalar i, j, k, l

	for(j=1; j<=bar2; j++) {
		pp[j] = &(J(1, bar1, NULL))
		for(i=1; i<=bar1; i++) {
			(*pp[j])[i] = &(J(i,j,i*j+j^2))
		}
	} 

	for(k=1; k<=bar2; k++) {
		for(l=1; l<=bar1; l++) {
			printf("\n j=%5.2f, i=%5.2f\n", k, l)
			*(*pp[k])[l]
		}
	}
}
end

sjlog using logs/ch13.09a, replace
mata: pointer2(2, 3)
sjlog close, replace

do myvecstr.mata

sjlog using logs/ch13.9a, replace
type myvecstr.mata
sjlog close, replace

do makevec.mata

sjlog using logs/ch13.9b, replace
type makevec.mata
sjlog close, replace

do myvecsub.mata

sjlog using logs/ch13.9c, replace
type myvecsub.mata
sjlog close, replace

sjlog using logs/ch13.9d, replace
mata:
makevec(42, 30, 12, 45, "red")
end
sjlog close, replace

do gbpval.mata

sjlog using logs/ch13.10, replace
type gbpval.mata
sjlog close, replace

do gbpval2.mata

sjlog using logs/ch13.11, replace
type gbpval2.mata
sjlog close, replace

mata: gbpval2(100)

local usdpergbp 2.06
mata: gbpval2(100)

do gbpval3.mata

sjlog using logs/ch13.12, replace
type gbpval3.mata
sjlog close, replace

sjlog using logs/ch14.11a, replace
mata
void function loadhash(string scalar filename)
{
	external A
	string colvector wpelts 
        real scalar fh
        real scalar i
        string line
        string wpnum
	A = asarray_create()
	wpelts = J(7,1,"")

	fh = fopen(filename, "r")
	while ((line=fget(fh))!=J(0,0,"")) {
		if(substr(line,1,6) != "Handle") {
			if(substr(line,1,5) == "Title") {
				i = 1
				wpelts[i] = substr(line,7,.)
			}
			if(substr(line,1, 11) == "Author-Name") {
				++i
				wpelts[i] = substr(line, 13,.)
			}
			if(substr(line,1, 13 ) == "Creation-Date") wpelts[6] = substr(line, 15,.)
			if(substr(line,1, 13 ) == "Revision-Date") wpelts[7] = substr(line, 15,.)
			if(substr(line,1,6) == "Number") {
				wpnum = substr(line,9,3)
				asarray(A, wpnum, wpelts)
				wpelts = J(7,1,"")
			}
		}
    }			
    fclose(fh)
	printf("\n%4.0f elements loaded in hash\n", asarray_elements(A))
}

void function gethash(string scalar key)
{
	external A
	asarray(A,key)
}
end
sjlog close, replace

sjlog using logs/ch14.11b, replace
mata: loadhash("bcwp.rdf")
mata: gethash("874")
mata: gethash("865")
mata: gethash("870")
mata: gethash("862")
sjlog close, replace


