
sjlog using logs/ch4.4, replace
use ex_employee, clear
generate byte beginspell = employer != employer[_n-1]
list, sepby(employer) noobs
sjlog close, replace

sjlog using logs/ch4.4a, replace
generate spellnr = sum(beginspell)
list, sepby(employer) noobs
sjlog close, replace

sjlog using logs/ch4.4b, replace
sort spellnr
by spellnr: generate length = _N if !missing(employer)
generate byte longspell = (length >=3 & !missing(length))
list year employer length longspell, sepby(employer) noobs
sjlog close, replace

sjlog using logs/ch4.5, replace
use ch45, clear
list fam person female age, sepby(fam) noobs
sjlog close, replace

drop nchild oldestchild oldestsibling
sjlog using logs/ch4.5a, replace
by fam: egen oldestchild = max(age) if age<=17
generate oldestsibling = cond(age < oldestchild & age <= 17, oldestchil, .)
list fam female age nadult sibs nboys nbros older oldestsibling, sepby(fam) ///
noobs
sjlog close, replace

sjlog using logs/ch4.7, replace
use gdp4cty, clear
keep cty gdp date
levelsof cty, local(gdplist)
reshape wide gdp, i(date) j(cty) string
describe
foreach c of local gdplist {
     local allcty "`allcty' gdp`c'"
}

foreach c of local allcty {
     local allbut: list allcty - c
     quietly regress `c' `allbut' date
     display _newline "Dependent variable `c':"
     matrix list e(b)
}
sjlog close, replace

sjlog using logs/ch4.8, replace
do mydofile
sjlog close, replace

sjlog using logs/ch4.8a, replace
sysuse auto, clear
display _newline "Datafile: `c(filename)' (N=`c(N)', k=`c(k)') as of `c(file date)'"
sjlog close, replace
