sjlog using logs/ch2.4, replace
use census2b, clear
describe
sjlog close, replace

sjlog using logs/ch2.4a, replace
summarize pop-drate
sjlog close,replace

sjlog using logs/ch2.4b, replace
codebook
sjlog close,replace

cscript do ch2.5.do
cscript do ch2.6.do
cscript do ch2.7.do

sjlog using logs/ch5.01, replace
use un, clear
describe
return list
local sb: sortedby
display "dataset sorted by: `sb'"
summarize troop, detail
scalar iqr = r(p75) - r(p25)
display "IQR = " iqr
scalar semean = r(sd) /sqrt(r(N))
display "Mean = " r(mean) " S.E. = " semean
sjlog close, replace

sjlog using logs/ch5.03, replace
use uniont, clear
xtset
return list
ttest age, by(union)
return list
sjlog close, replace

sjlog using logs/ch5.05, replace
use un, clear
regress deaths duration troop
ereturn list
sjlog close, replace

sjlog using logs/ch5.05a, replace
local regressors: colnames e(b)
display "Regressors: `regressors'
sjlog close, replace

sjlog using logs/ch5.06, replace
estat summarize
sjlog close, replace

sjlog using logs/ch5.07, replace
matrix list e(b)
sjlog close, replace

sjlog using logs/ch5.08, replace
estat vce
sjlog close, replace

sjlog using logs/ch5.09, replace
use usairquality, clear
quietly regress so2 temp manuf pop
estimates store model1
quietly regress so2 temp pop wind
estimates store model2
quietly regress so2 temp wind precip days
estimates store model3
quietly regress so2 temp manuf pop wind precip days
estimates store model4
estimates table model1 model2 model3 model4, stat(r2_a rmse) ///
	b(%7.3f) se(%6.3g) p(%4.3f)
sjlog close, replace

sjlog using logs/ch5.10, replace
estimates table model4 model1 model3 model2, stat(r2_a rmse ll) ///
	b(%7.3g) star varlabel title("Models of sulphur dioxide concentration")
sjlog close, replace

sjlog using logs/ch5.10aa, replace
estimates for model1 model2 model3 model4: test temp = -1.6
sjlog close, replace

sjlog using logs/ch5.10ab, replace
estimates replay model1
sjlog close, replace

sjlog using logs/ch5.10ac, replace
forvalues i = 1/4 {
     estimates restore model`i'
     estimates notes: from file `c(filename)' saved `c(filedate)'
     estimates save so2_model`i', replace
}
sjlog close, replace

sjlog using logs/ch5.10ad, replace
clear
estimates clear
estimates describe using so2_model3
estimates use so2_model3
estimates store so2_model3
estimates table *
sjlog close, replace

sjlog using logs/ch5.10a, replace
use usairquality, clear
eststo clear
eststo: quietly regress so2 temp manuf pop
eststo: quietly regress so2 temp pop wind
eststo: quietly regress so2 temp wind precip days
eststo: quietly regress so2 temp manuf pop wind precip days
esttab using esttab_example.tex, ar2 label se nostar nodepvars brackets ///
	nomtitles title("Models of sulphur dioxide concentration") booktabs ///
	alignment(D{.}{.}{-1}) replace
sjlog close, replace

sjlog using logs/ch5.10b, replace
use nestates, clear
keep if inlist(year,1990,1995,2000)
drop dpi*
keep year popCT popMA popRI
order year
xpose, clear
drop in 1
generate str state = "CT" in 1
replace state = "MA" in 2
replace state = "RI" in 3
rename v1 pop1990
rename v2 pop1995
rename v3 pop2000
order state
list, noobs
sjlog close, replace

sjlog using logs/ch5.10c, replace
reshape long pop, i(state) j(year)
list, noobs sepby(state)
sjlog close, replace

sjlog using logs/ch5.11, replace
use mathpnl_long, clear
describe
sjlog close, replace

sjlog using logs/ch5.11a, replace
xtset
tabulate year
sjlog close, replace

sjlog using logs/ch5.12, replace
use mathpnl_wide, clear
describe
sjlog close, replace

sjlog using logs/ch5.13, replace
reshape long expp revpp avgsal math4score math7score, i(distid) j(year)
sjlog close, replace

sjlog using logs/ch5.13a, replace
describe
sjlog close, replace

sjlog using logs/ch5.14, replace
reshape wide expp revpp avgsal math4score math7score, i(distid) j(year)
sjlog close, replace

sjlog using logs/ch5.15, replace
use mathpnl1992, clear
append using mathpnl1994
append using mathpnl1996
append using mathpnl1998
label data ""
save mathpnl_appended, replace
describe
sjlog close, replace

rm mathpnl_appended.dta

sjlog using logs/ch5.16, replace
use mathpnl_long, clear
keep distid year
keep if year == 1982
generate int state = runiform() * 50 + 1
drop year
label variable state "State code"
label data ""
sort distid
save mathpnl_state, replace
describe
sjlog close, replace

sjlog using logs/ch5.17, replace
use mathpnl_long, clear
merge m:1 distid using mathpnl_state
capture assert _merge == 3
drop _merge
save mathpnl_longs, replace
sjlog close, replace

use mathpnl_wide,clear
forvalues i=1992(2)1998 {
        preserve
        keep distid *`i'
        label data ""
        save mathpnl`i'm, replace
        restore
}


sjlog using logs/ch5.18, replace
use mathpnl1992m, clear
forvalues y = 1994(2)1998 {
     merge 1:1 distid using mathpnl`y'm
     assert _merge == 3
     drop _merge
}
save mathpnlm, replace
sjlog close, replace

sjlog using logs/ch5.19, replace
use mathpnl_wide, clear
preserve
stack expp1992 avgsal1992 expp1998 avgsal1998, into(expp sal) wide clear
scatter expp1992 expp1998 sal, m(oh x) scheme(s2mono) ///
  title("School District Expenditures vs. Average Salaries")  ///
  xtitle("Average salaries") ytitle("Expenditures") ///
  legend(position(5) ring(0) label(1 "1992") label(2 "1998"))
restore
sjlog close, replace

graph display, xsize(4) ysize(3)
graph export fig5_19.eps, replace

sjlog using logs/ch5.20, replace
use mathpnl_long, clear
separate expp, by(year) veryshortlabel
summarize expp*
sjlog close, replace
